'use strict';

const debug = require('debug')('ruo');
const Router = require('router');

var _require = require('../utility');

const wrapRoute = _require.wrapRoute,
      wrapMiddleware = _require.wrapMiddleware;


module.exports = api => {
  const router = Router();

  for (let path in api.paths) {
    for (let method in api.paths[path]) {
      let handler = api.paths[path][method].__handler__;
      if (typeof handler === 'object') {
        // array of middlewares
        handler = handler.map((func, index) => {
          return index === handler.length - 1 ? wrapRoute(func) : wrapMiddleware(func);
        });
      } else {
        handler = wrapRoute(handler);
      }
      let endpoing = path.replace(/\{/g, ':').replace(/\}/g, '');
      endpoing = `${ api.basePathPrefix }${ endpoing }`;
      debug('mount handler', method, endpoing);
      router[method](endpoing, handler);
    }
  }

  return router;
};